/*
 * 订单商品
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class OrderProductController : BaseController
    {
        public OrderProductController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 订单商品列表

        /// <summary>
        /// 根据条件查询订单商品列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(OrderProduct data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;

            string Condition = "";
            Condition += "ProductName:\"" + data.ProductName + "\",";

            if (!string.IsNullOrEmpty(Condition))
            { 
                Condition = Condition.TrimEnd(',');
                Condition = ", where: {" + Condition + "}";
            }
            ViewBag.Condition = Condition;
            return View();
        }

        #endregion

        #region 根据条件查询订单商品列表

        /// <summary>
        /// 订单商品列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(OrderProduct data, int page = 1, int limit = 30)
        {
            
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("ProductName", "2"); //商品名称

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("OrderProduct", Fields, "Id desc", "False", page, limit);
            
            return Json(obj);
        }

        #endregion

        #region 增加订单商品

        /// <summary>
        /// 增加或修改订单商品信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;

            return View();
        }

        #endregion

        #region 增加订单商品

        /// <summary>
        /// 增加或修改订单商品信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(OrderProduct data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            Fields.Add("ProductName", data.ProductName); //商品名称
Fields.Add("ProductPrice", data.ProductPrice); //商品单价
Fields.Add("ProductCount", data.ProductCount); //商品数量
Fields.Add("TotalPrice", data.TotalPrice); //小计
Fields.Add("TotalIntegral", data.TotalIntegral); //积分
Fields.Add("ProductPhoto", data.ProductPhoto); //商品缩略图
Fields.Add("NormDetail", data.NormDetail); //规则描述

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Add("OrderProduct", Fields, 0);
            AddSysLog(data.Id.ToString(), "OrderProduct", "add");
            db.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 修改订单商品

        /// <summary>
        /// 增加或修改订单商品信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;

            OrderProduct editData = db.OrderProduct.FirstOrDefault(m => m.Id == Id) ?? new OrderProduct();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改订单商品

        /// <summary>
        /// 增加或修改订单商品信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(OrderProduct data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            Fields.Add("ProductName", data.ProductName); //商品名称
Fields.Add("ProductPrice", data.ProductPrice); //商品单价
Fields.Add("ProductCount", data.ProductCount); //商品数量
Fields.Add("TotalPrice", data.TotalPrice); //小计
Fields.Add("TotalIntegral", data.TotalIntegral); //积分
Fields.Add("ProductPhoto", data.ProductPhoto); //商品缩略图
Fields.Add("NormDetail", data.NormDetail); //规则描述

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("OrderProduct", Fields, data.Id);
            AddSysLog(data.Id.ToString(),"OrderProduct","update");
            db.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 删除订单商品信息

        /// <summary>
        /// 删除订单商品信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"OrderProduct","del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Delete("OrderProduct", id);
            }
            db.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"OrderProduct","open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("OrderProduct", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"OrderProduct","close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("OrderProduct", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Sort("OrderProduct", Sort, Id);
            
            AddSysLog(Id.ToString(), "OrderProduct", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count;i++ )
            {
                JsonData dr = list[i];
                
                db.OrderProduct.Add(new OrderProduct()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,
                    
                });
                db.SaveChanges();
            }
            AddSysLog("0", "OrderProduct", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(OrderProduct data)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("ProductName", "2"); //商品名称

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("OrderProduct", Fields, "Id desc", "False", 1, 20000, "", "", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();
            
            result.Add("Fields", ReturnFields);
            AddSysLog("0", "OrderProduct", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
